const wsContext = {
	target : 'ski',

	mapCommand : new Map(),
	keyCommand : 'key',
	port : 20000,
	url : 'ws://localhost',
	
	mapControl : new Map(),
	portControl : 20009,
	urlControl : 'ws://localhost',
	
	mapBinary : new Map,
};

wsContext.OpenWebSocketCommand = function(fnOpen=undefined, fnClose=undefined)
{
	wsContext.wsCommand = new WebSocket(wsContext.url+':'+(wsContext.port).toString());
	
	if (fnOpen != undefined)
		wsContext.wsCommand.onopen = fnOpen;

	wsContext.wsCommand.onmessage = function(evt) { 
		var objJSON = null;
		
		try 
		{
			objJSON = JSON.parse(evt.data);
		} 
		catch (e) 
		{
			alert("Parsing error data :"+evt.data);
			alert("Parsing error:"+e);
			return;
		}

		if (objJSON && typeof objJSON === "object") 
		{
            const typeObj = typeof objJSON[wsContext.keyCommand];
            if (typeObj === "string" || typeObj === "number")
            {
                const fn = wsContext.mapCommand.get(objJSON[wsContext.keyCommand]);
                if (fn && typeof fn === "function")
                {
                    fn(objJSON);
                }
                else 
                {
                    const fnDefault = wsContext.mapCommand.get('*');
                    if (fnDefault && typeof fnDefault === "function")
                    {
                        fnDefault(objJSON);
                    }
                }
            }
		}
	}
	
	if (fnClose != undefined)
		wsContext.wsCommand.onclose = fnClose;
	else
		wsContext.wsCommand.onclose = function()	{ wsContext.wsCommand = null; }
}

wsContext.OpenWebSocketBinary = function(url, port, fnMessage, fnOpen=undefined, fnClose=undefined)
{
	const urlBinary = url+':'+port.toString();
	var wsFlowBinary = new WebSocket(urlBinary);
	wsFlowBinary.binaryType = 'arraybuffer';
	wsContext.mapBinary.set(urlBinary, wsFlowBinary);

	if (fnMessage != undefined)
		wsFlowBinary.onmessage = fnMessage;
	
	if (fnOpen != undefined)
		wsFlowBinary.onopen = fnOpen;
/*
		var wsOpen = new Function('open_ws_binary_'+urlBinary, 'fnOpen(evt,"'+urlBinary+'");');
		wsContext.wsOpen1 = new Function('evt', '"'+open_ws_binary+', 'alert("YES !!!");');
		wsFlowBinary.onopen = wsContext.wsOpen1;
*/	
	if (fnClose != undefined)
		wsFlowBinary.onclose = fnClose;
}

wsContext.OpenWebSocketControl = function(fnOpen=undefined, fnClose=undefined)
{
	wsContext.wsControl = new WebSocket(wsContext.urlControl+':'+(wsContext.portControl).toString());
	
	if (fnOpen != undefined)
		wsContext.wsControl.onopen = fnOpen;

	wsContext.wsControl.onmessage = function(evt) { 
		var objJSON = null;
		
		try 
		{
			objJSON = JSON.parse(evt.data);
		} 
		catch (e) 
		{
			alert("Parsing error data :"+evt.data);
			alert("Parsing error:"+e);
			return;
		}

		if (objJSON && typeof objJSON === "object" && typeof objJSON.key === "string") 
		{
			const fn = wsContext.mapControl.get(objJSON.key);
			if (fn && typeof fn === "function")
				fn(objJSON);
		}
	}
	
	if (fnClose != undefined)
		wsContext.wsControl.onclose = fnClose;
	else
		wsContext.wsControl.onclose = function() { wsContext.wsControl = null; }
}

