function OnOpenWebSocketCommand()
{
	wsContext.wsCommand.send(JSON.stringify({key : '<race_load>' }));
}

function OnCommandRaceLoad(objJSON)
{
	wsContext.notify_race = objJSON;

	const tCompetition = adv.GetTable(objJSON, 'Competition');
	const tCompetition_Course = adv.GetTable(objJSON, 'Competition_Course');
	const tCompetition_Course_Phase = adv.GetTable(objJSON, 'Competition_Course_Phase');

	document.querySelector("#head .name").innerHTML = tCompetition.GetCell('Nom', 0);
	document.querySelector("#head .place").innerHTML = tCompetition_Course.GetCell('Libelle', 0);
	document.querySelector("#head .title").innerHTML = tCompetition_Course_Phase.GetCell('Libelle', 0);
	document.querySelector("#head .mode").innerHTML = 'Ranking';
	
	// Chargement de toutes les épreuves ...
	const cmd = { key : '<epreuve_load>',  epreuve : '' };	
	wsContext.wsCommand.send(JSON.stringify(cmd));
}

function OnCommandEpreuveLoad(objJSON)
{
	wsContext.notify_ranking = objJSON;

	const tRanking = adv.GetTableUnique(wsContext.notify_ranking, 'ranking');
	canoe.SetColumnNameRanking(tRanking);

	const course_phase = canoe.GetCodeCoursePhase();
	tRanking.OrderBy('Tps'+course_phase+', Dossard');
	
	if (wsContext.epreuve == '')
		SetCurrentEpreuve(tRanking);
	
	if (wsContext.epreuve != '')
		SetBest(tRanking, course_phase, wsContext.epreuve, -1);
	
	ShowRanking(tRanking);
}

function OnBroadcastTv(objJSON)
{
	if (objJSON.channel == 'startlist')
		window.location = './startlist.html';
}

function OnBroadcastBibTime(objJSON) 
{
	if (typeof wsContext.notify_ranking === 'object')
	{
		const passage = parseInt(objJSON.passage);
		const bib = objJSON.bib;
		const time_chrono = objJSON.time_chrono;
		
		if (passage >= 1)
			DoBroadcastBibTimeInter(passage, bib, time_chrono, objJSON.diff_categ);
		else
			DoBroadcastBibTimeFinish(objJSON);
	}
}

function DoBroadcastBibTimeInter(passage, bib, time_chrono, diff_categ) 
{
	if (bib == wsContext.running_bib)
	{
		if (time_chrono != adv.chrono.KO && time_chrono != adv.chrono.DNS && wsContext.timeoutFinish == null)
			ShowRunningInter(time_chrono, diff_categ);
	}
}

function DoBroadcastBibTimeFinish(objJSON) 
{
	const bib = objJSON.bib;
	const tRanking = adv.GetTableUnique(wsContext.notify_ranking, 'ranking');
	const course_phase = canoe.GetCodeCoursePhase();
	const codeActivite = canoe.GetCodeActivite();
	
	for (let i=0;i<tRanking.GetNbRows();i++)
	{
		if (bib == tRanking.GetCell('Dossard', i))
		{
			tRanking.SetCell('Tps_chrono'+course_phase,i, objJSON.time_chrono);
			
			const oldTps = tRanking.GetCellInt('Tps'+course_phase, i);
			const newTps = canoe.UpdateSlalomFinishTime(tRanking, i);
			
			tRanking.SetRankingGroup('Cltc'+course_phase, 'Tps'+course_phase+', Dossard', 'Code_categorie');
			tRanking.SetRanking('Clt'+course_phase, 'Tps'+course_phase+', Dossard');
	
			if (newTps != adv.chrono.KO && newTps != adv.chrono.DNS)
			{
				i = tRanking.GetIndexRow('Dossard', bib);	// SetRanking => Order => old i ko ...
				wsContext.epreuve = tRanking.GetCell('Code_categorie', i);
				ShowRunningFinish(tRanking, i, course_phase);
			}

			// Ré-Affichage ...
			ShowRanking(tRanking);
	
			SetBest(tRanking, course_phase, tRanking.GetCell('Code_categorie', i), i);
			break;
		}
	}
}

function OnBroadcastRunErase(objJSON)
{
	Reload();
}

function Reload()
{
	wsContext.epreuve = '';
	
	if (wsContext.timeoutFinish != null)
	{
		window.clearTimeout(wsContext.timeoutFinish);
		wsContext.timeoutFinish = null;
	}

	if (wsContext.timeoutInter != null)
	{
		window.clearTimeout(wsContext.timeoutInter);
		wsContext.timeoutInter = null;
	}
	
	OnOpenWebSocketCommand();
	ClearRunning();
	ClearBest();
}

function SetCurrentEpreuve(tRanking)
{
	const course_phase = canoe.GetCodeCoursePhase();
	var lastHeureDep = 0;

	wsContext.epreuve = '';
	for (let i=0;i<=tRanking.GetNbRows();i++)
	{
		if (tRanking.GetCellInt('Tps'+course_phase,i) >= adv.chrono.OK)
		{
			if (tRanking.GetCellInt('Heure_depart'+course_phase,i) > lastHeureDep)
			{
				lastHeureDep = tRanking.GetCellInt('Heure_depart'+course_phase,i);
				wsContext.epreuve = tRanking.GetCell('Code_categorie',i);
			}
		}
	}

	if (wsContext.epreuve != '')
		SetBest(tRanking, course_phase, wsContext.epreuve, -1);
}

function OnFlowOnCourse(objJSON)
{
	if (wsContext.timeoutFinish != null || wsContext.timeoutInter != null)
		return;

	const tOnCourse = adv.GetTableUnique(objJSON, 'table');
	if (tOnCourse && typeof tOnCourse === 'object')
	{
		const nb = tOnCourse.GetNbRows();
		if (wsContext.running_bib > 0)
		{
			const i = tOnCourse.GetIndexRow('bib', wsContext.running_bib);
			if (i >= 0)
			{
				document.querySelector("#block_running .time").innerHTML = tOnCourse.GetCellChrono('time', i, 'HHMMSSCC');
				return;
			}
		}
		
		if (nb > 0)
		{		
			if (typeof wsContext.notify_ranking === 'object')
			{
				wsContext.running_bib = tOnCourse.GetCell('bib', nb-1);
				 
				const tRanking = adv.GetTableUnique(wsContext.notify_ranking, 'ranking');
				const i = tRanking.GetIndexRow('Dossard', wsContext.running_bib);

				if (i >= 0)
				{
					ShowRunning(tRanking, i, tOnCourse.GetCellChrono('time', nb-1, 'HHMMSSCC'));
					return;
				}
			}
		}

		wsContext.running_bib = -1;
		ClearRunning();
	}
}

function HideRow(row)
{
	document.querySelector('#block_ranking .row'+row).style.display = 'none';
}

function ShowRow(row)
{
	document.querySelector('#block_ranking .row'+row).style.display = 'block';
}

function HideRows()
{
	for (let i=1;i<=12;i++)
		HideRow(i);
}

function ShowRanking(tRanking)
{
	HideRows();
	if (tRanking && typeof tRanking === 'object')
	{
		const course_phase = canoe.GetCodeCoursePhase();

		var row = 1;
		var i = 0;
		while (row <= 12 && i < tRanking.GetNbRows())
		{
			if (tRanking.GetCell('Code_categorie', i) == wsContext.epreuve && 
				tRanking.GetCellInt('Tps'+course_phase,i, adv.chrono.KO) != adv.chrono.KO
			)
			{
				ShowRankingRow(row, tRanking, i, course_phase);
				++row;
			}
			++i;
		}
	}
}

function ShowRankingRow(row, tRanking, i, course_phase)
{
	if (tRanking.GetCellInt('Tps'+course_phase, i) > 0)
		document.querySelector('#block_ranking .row'+row+' .rank').innerHTML = tRanking.GetCell('Cltc'+course_phase, i);
	else
		document.querySelector('#block_ranking .row'+row+' .rank').innerHTML = '';
		
	document.querySelector('#block_ranking .row'+row+' .bib').innerHTML = tRanking.GetCell('Dossard', i);
	document.querySelector('#block_ranking .row'+row+' .identity').innerHTML = tRanking.GetCell('Bateau', i);
	
	const code_nation = tRanking.GetCell('Code_nation', i);
	document.querySelector('#block_ranking .row'+row+' .nation').innerHTML = code_nation;

	if (code_nation.length > 0)
	{
		document.querySelector('#block_ranking .row'+row+' .img_nation').innerHTML = "<img src='./img/flags/"+code_nation+".png' height='48' width='48' />";
	}
	else
	{
		document.querySelector('#block_ranking .row'+row+' .img_nation').innerHTML = '';
	}

	document.querySelector('#block_ranking .row'+row+' .time').innerHTML = tRanking.GetCellChrono('Tps'+course_phase, i, 'HHMMSSCC');

	ShowRow(row);
}

function ClearRunning()
{
	document.querySelector('#block_running .bib').innerHTML = '';
	document.querySelector('#block_running .identity').innerHTML = '';
	document.querySelector('#block_running .time').innerHTML = '';
	document.querySelector('#block_running .rank').style.display = 'none';
	document.querySelector('#block_running .diff').style.display = 'none';
}

function ShowRunning(tRanking, i, time_running)
{
	document.querySelector('#block_running .bib').innerHTML = tRanking.GetCell('Dossard', i);
	document.querySelector('#block_running .identity').innerHTML = tRanking.GetCell('Bateau', i);

	const code_nation = tRanking.GetCell('Code_nation', i);
	document.querySelector('#block_running .nation').innerHTML = code_nation;
	if (code_nation.length > 0)
	{
		document.querySelector('#block_running .img_nation').innerHTML = "<img src='./img/flags/"+code_nation+".png' height='48' width='48' />";
	}
	else
	{
		document.querySelector('#block_running .img_nation').innerHTML = '';
	}
	
	if (time_running != '')
		document.querySelector('#block_running .time').innerHTML = time_running;
	
	document.querySelector('#block_running .rank').style.display = 'none';
	document.querySelector('#block_running .diff').style.display = 'none';
}

function ShowRunningInter(time_chrono, diff_categ)
{
	if (wsContext.timeoutInter != null)
		window.clearTimeout(wsContext.timeoutInter);
	wsContext.timeoutInter = window.setTimeout(function() { wsContext.timeoutInter = null; }, wsContext.timeoutInterDelay);
	
	document.querySelector('#block_running .time').innerHTML = adv.GetChrono(time_chrono, 'HHMMSSCC');
	document.querySelector('#block_running .rank').style.display = 'none';
	
	if (diff_categ === undefined)
	{
		document.querySelector('#block_running .diff').style.display = 'none';
	}
	else
	{
		document.querySelector('#block_running .diff').innerHTML = adv.GetChronoDiffMMSSCC(diff_categ);
		document.querySelector('#block_running .diff').style.display = 'block';
	
		if (diff_categ > 0)
		{
			document.querySelector('#block_running .diff').classList.remove('green');
			document.querySelector('#block_running .diff').classList.add('red');
		}
		else
		{
			document.querySelector('#block_running .diff').classList.add('green');
			document.querySelector('#block_running .diff').classList.remove('red');
		}
	}
}

function ShowRunningFinish(tRanking, i, course_phase)
{
	if (wsContext.timeoutInter != null)
	{
		window.clearTimeout(wsContext.timeoutInter);
		wsContext.timeoutInter = null;
	}

	if (wsContext.timeoutFinish != null)
		window.clearTimeout(wsContext.timeoutFinish);
	wsContext.timeoutFinish = window.setTimeout(function() { wsContext.timeoutFinish = null; SetBest(tRanking, course_phase, wsContext.epreuve, -1); }, wsContext.timeoutFinishDelay);
	
	wsContext.running_bib = -1;
	
	var time_chrono = tRanking.GetCellInt('Tps'+course_phase, i, adv.chrono.KO);
	
	document.querySelector('#block_running .bib').innerHTML = tRanking.GetCell('Dossard', i);
	document.querySelector('#block_running .identity').innerHTML = tRanking.GetCell('Bateau', i);
	document.querySelector('#block_running .time').innerHTML = adv.GetChronoHHMMSSCC(time_chrono);

	if (time_chrono >= adv.chrono.OK)
	{	
		document.querySelector('#block_running .rank').innerHTML = tRanking.GetCell('Cltc'+course_phase, i);
		document.querySelector('#block_running .rank').style.display = 'block';

		const diff_categ = tRanking.GetDiffTime('Tps'+course_phase, i, 'Code_categorie');
		if (diff_categ === undefined || diff_categ === null)
		{
			document.querySelector('#block_running .diff').style.display = 'none';
		}
		else
		{
			document.querySelector('#block_running .diff').innerHTML = adv.GetChronoDiffMMSSCC(diff_categ); 
			document.querySelector('#block_running .diff').style.display = 'block';
		
			if (diff_categ > 0)
			{
				document.querySelector('#block_running .diff').classList.remove('green');
				document.querySelector('#block_running .diff').classList.add('red');
			}
			else
			{
				document.querySelector('#block_running .diff').classList.add('green');
				document.querySelector('#block_running .diff').classList.remove('red');
			}
		}
	}
	else
	{
		document.querySelector('#block_running .rank').style.display = 'none';
		document.querySelector('#block_running .diff').style.display = 'none';
	}
}

function ClearBest()
{
	document.querySelector('#block_running .best_identity').innerHTML = '';
	document.querySelector('#block_running .best_time').innerHTML = '';
}

function ShowBest(tRanking, i, course_phase)
{
	document.querySelector('#block_running .best_identity').innerHTML = tRanking.GetCell('Bateau', i);
	document.querySelector('#block_running .best_time').innerHTML = tRanking.GetCellChrono('Tps'+course_phase, i, 'HHMMSSCC');
}

function SetBest(tRanking, course_phase, epreuve, row)
{
	for (let i=0;i<=tRanking.GetNbRows();i++)
	{
		if (tRanking.GetCell('Code_categorie', i) == epreuve &&
			tRanking.GetCellInt('Tps'+course_phase, i) >= adv.chrono.OK &&
			i != row
		)
		{
			ShowBest(tRanking, i, course_phase);
			return;
		}
	}
}

function Init()
{
	wsContext.lang = 'en';
	wsContext.url = wsParams.url;
	wsContext.port = wsParams.port;

	wsContext.epreuve = '';
	wsContext.running_bib = -1;
	
	wsContext.timeoutFinish = null;
	wsContext.timeoutFinishDelay = 10000;
	
	wsContext.timeoutInter = null;
	wsContext.timeoutInterDelay = 105000;
	
	// Command Notification
	wsContext.mapCommand.set('<race_load>', OnCommandRaceLoad);
	wsContext.mapCommand.set('<epreuve_load>', OnCommandEpreuveLoad);
	
	// Broadcast Notification
	wsContext.mapBroadcast.set('<tv>', OnBroadcastTv);
	wsContext.mapBroadcast.set('<bib_time>', OnBroadcastBibTime);
	wsContext.mapBroadcast.set('<run_erase>', OnBroadcastRunErase);
	
	// Flow Notification
	wsContext.mapFlow.set('<on_course>', OnFlowOnCourse);

	// Ouverture ws 
	wsContext.OpenWebSocketCommand(OnOpenWebSocketCommand);
	wsContext.OpenWebSocketBroadcast();
	wsContext.OpenWebSocketFlow();
	
	ClearBest();
}

