function OnOpenWebSocketCommand()
{
	wsContext.wsCommand.send(JSON.stringify({key : '<race_load>' }));
}

function OnCommandRaceLoad(objJSON)
{
	wsContext.notify_race = objJSON;

	const tCompetition = adv.GetTable(objJSON, 'Competition');
	const tCompetition_Course = adv.GetTable(objJSON, 'Competition_Course');
	const tCompetition_Course_Phase = adv.GetTable(objJSON, 'Competition_Course_Phase');

	document.querySelector("#head .name").innerHTML = tCompetition.GetCell('Nom', 0);
	document.querySelector("#head .place").innerHTML = tCompetition_Course.GetCell('Libelle', 0);
	document.querySelector("#head .title").innerHTML = tCompetition_Course_Phase.GetCell('Libelle', 0);
	document.querySelector("#head .mode").innerHTML = 'Startlist';
	
	wsContext.wsCommand.send(JSON.stringify({key : '<ranking_load>' }));
}

function OnCommandRankingLoad(objJSON)
{
	wsContext.notify_ranking = objJSON;

	const tRanking = adv.GetTableUnique(objJSON, 'ranking');
	const course_phase = canoe.GetCodeCoursePhase();
	
	tRanking.OrderBy('Rang'+course_phase+', Dossard');
	
	if (wsContext.categ == '')
		SetCurrentCateg(tRanking);
	
	ShowStartlist(tRanking);
}

function OnBroadcastTv(objJSON)
{
	if (objJSON.channel == 'ranking')
		window.location = './ranking.html';
}

function OnBroadcastModeChrono(objJSON)
{
	Reload();
}

function Reload()
{
	wsContext.categ = '';
	wsContext.timeoutScrollingIndex = 0;
	if (wsContext.timeoutScrolling != null)
	{
		window.clearTimeout(wsContext.timeoutScrolling);
		wsContext.timeoutScrolling = null;
	}
	
	OnOpenWebSocketCommand();
}

function SetCurrentCateg(tRanking)
{
	const course_phase = canoe.GetCodeCoursePhase();
	var lastHeureDep = 0;

	wsContext.categ = '';
	for (let i=0;i<=tRanking.GetNbRows();i++)
	{
		if (tRanking.GetCellInt('Heure_depart'+course_phase,i) > lastHeureDep)
		{
			lastHeureDep = tRanking.GetCellInt('Heure_depart'+course_phase,i);
			wsContext.categ = tRanking.GetCell('Code_categorie',i);
		}
	}
}

function HideRow(row)
{
	document.querySelector('#block_startlist .row'+row).style.display = 'none';
}

function ShowRow(row)
{
	document.querySelector('#block_startlist .row'+row).style.display = 'block';
}

function HideRows()
{
	for (let i=1;i<=14;i++)
		HideRow(i);
}

function ShowStartlist(tRanking)
{
	HideRows();
	if (tRanking && typeof tRanking === 'object')
	{
		const course_phase = canoe.GetCodeCoursePhase();

		var row = 1;
		var i = wsContext.timeoutScrollingIndex;
		while (row <= 14 && i < tRanking.GetNbRows())
		{
			if (tRanking.GetCell('Code_categorie', i) == wsContext.categ || wsContext.categ == '')
			{
				ShowStartlistRow(row, tRanking, i, course_phase);
				++row;
			}
			++i;
		}
		
		wsContext.timeoutScrollingIndex = i;
		var empty = true;
		while (i < tRanking.GetNbRows())
		{
			if (tRanking.GetCell('Code_categorie', i) == wsContext.categ)
			{
				empty = false;
				break;
			}
			--i;
		}
		if (empty)
			wsContext.timeoutScrollingIndex = 0;
		
		wsContext.timeoutScrolling = window.setTimeout(function() { ShowStartlist(tRanking); }, wsContext.timeoutScrollingDelay);
	}
}

function ShowStartlistRow(row, tRanking, i, course_phase)
{
	document.querySelector('#block_startlist .row'+row+' .rank').innerHTML = tRanking.GetCell('Rang'+course_phase, i);
	document.querySelector('#block_startlist .row'+row+' .bib').innerHTML = tRanking.GetCell('Dossard', i);
	document.querySelector('#block_startlist .row'+row+' .identity').innerHTML = tRanking.GetCell('Bateau', i);
	document.querySelector('#block_startlist .row'+row+' .nation').innerHTML = tRanking.GetCell('Code_nation', i);
	document.querySelector('#block_startlist .row'+row+' .categ').innerHTML = tRanking.GetCell('Code_categorie', i);
	document.querySelector('#block_startlist .row'+row+' .time').innerHTML = tRanking.GetCellChrono('Heure_depart'+course_phase, i, 'HHMMSS');

	ShowRow(row);
}

function Init()
{
	wsContext.url = 'ws://localhost';
//	wsContext.url = 'ws://192.168.1.10';
	wsContext.port = 20000;
	
	wsContext.categ = '';
	
	wsContext.timeoutScrolling = null;
	wsContext.timeoutScrollingDelay = 10000;
	wsContext.timeoutScrollingIndex = 0;
	
	// Command Notification
	wsContext.mapCommand.set('<race_load>', OnCommandRaceLoad);
	wsContext.mapCommand.set('<ranking_load>', OnCommandRankingLoad);
	
	// Broadcast Notification
	wsContext.mapBroadcast.set('<mode_chrono>', OnBroadcastModeChrono);
	wsContext.mapBroadcast.set('<tv>', OnBroadcastTv);
	
	// Ouverture ws 
	wsContext.OpenWebSocketCommand(OnOpenWebSocketCommand);
	wsContext.OpenWebSocketBroadcast();
}

