function OnOpenWebSocketCommand()
{
	wsContext.wsCommand.send(JSON.stringify({key : '<race_load>', key_race : '*' }));
}

function OnCommandRaceLoad(objJSON)
{
//	alert("OnCommandRaceLoad :"+JSON.stringify(objJSON));
	wsContext.notify_race = objJSON;

	// Chargement de toutes les épreuves ...
	const cmd = { key : '<epreuve_load>',  epreuve : '' };	
	wsContext.wsCommand.send(JSON.stringify(cmd));
}

function OnCommandEpreuveLoad(objJSON)
{
//	alert("OnCommandEpreuveLoad :"+JSON.stringify(objJSON));
	wsContext.notify_ranking = objJSON;

	const tRanking = adv.GetTableUnique(wsContext.notify_ranking, 'ranking');
	canoe.SetColumnNameRanking(tRanking);
}

function OnBroadcastPenaltyAdd(objJSON) 
{
	const bib = objJSON.bib;
	const porte = objJSON.gate;
	const pena = objJSON.penalty;
	
	if (bib == wsContext.bib_select)
	{
	}

//	alert('OnBroadcastPenaltyAdd bib='+bib+', porte='+porte+', pena='+pena);
}

function OnBroadcastBibTime(objJSON) 
{
	if (typeof wsContext.notify_ranking === 'object')
	{
		const passage = parseInt(objJSON.passage);
		if (passage >= 1)
			DoBroadcastBibTimeInter(objJSON, passage);
		else
			DoBroadcastBibTimeFinish(objJSON);
	}
}

function DoBroadcastBibTimeInter(objJSON, inter) 
{
	const bib = objJSON.bib;

	const course_phase_inter = canoe.GetCodeCoursePhase()+'_inter'+inter;
	const tRanking = adv.GetTableUnique(wsContext.notify_ranking, 'ranking');
	const iRow = tRanking.GetIndexRow('Dossard', bib);
	
	if (bib == wsContext.bib_select)
	{
		const time_chrono = adv.GetChronoHHMMSSCC(objJSON.time_chrono);
		
		var diff_chrono = '';
		var color_chrono = '';
		
		if (objJSON.diff_categ != undefined)
		{
			diff_chrono = adv.GetChronoDiffMMSSCC(objJSON.diff_categ);
			if (objJSON.diff_categ > 0)
				color_chrono = 'red';
			else
				color_chrono = 'green';
		}
		else
		{
			if (objJSON.time_chrono > 0)
				color_chrono = 'green';
			else
				color_chrono = 'red';
		}

		if (wsContext.timeoutInter != null)
		{
			window.clearTimeout(wsContext.timeoutInter);
			wsContext.timeoutInter = null;
		}
		
		wsContext.timeoutInter = window.setTimeout(function() { 
				wsContext.timeoutInter = null; 
				HideBlockInter();
			},	wsContext.timeoutInterDelay
		);

	//	alert(time_chrono+'/'+diff_chrono+'/'+color_chrono);

		document.querySelector('#block_start .bib').innerHTML = bib;
		SetName('#block_start', tRanking, iRow);
		SetNation('#block_start', tRanking, iRow);
		SetCateg('#block_start', tRanking, iRow);

		document.querySelector('#block_inter .time').innerHTML = time_chrono;
		document.querySelector("#block_inter .diff").innerHTML = diff_chrono;
		
		if (color_chrono == 'red')
		{
			document.querySelector("#block_inter").classList.remove('green');
			document.querySelector("#block_inter").classList.add('red');
		}
		else 
		{
			document.querySelector("#block_inter").classList.add('green');
			document.querySelector("#block_inter").classList.remove('red');
		}

		document.querySelector('#block_inter .leader_name').innerHTML = '';
		document.querySelector('#block_inter .leader_time').innerHTML = '';

		if (wsContext.leader_index >= 0)
		{
			const tpsInter = tRanking.GetCellInt('Tps'+course_phase_inter, wsContext.leader_index);
			if (tpsInter > 0)
			{
				SetLeaderName(document.querySelector('#block_inter .leader_name'));
				document.querySelector('#block_inter .leader_time').innerHTML = tRanking.GetCellChrono('Tps'+course_phase_inter, wsContext.leader_index, 'HHMMSSCC');
			}
		}

		ShowBlockInter();
	}
	
	if (iRow >= 0)
		tRanking.UpdateRankingTime(iRow, tRanking.GetIndexColumn('Tps'+course_phase_inter), tRanking.GetIndexColumn('Cltc'+course_phase_inter), tRanking.GetCellInt('Tps'+course_phase_inter,iRow), objJSON.time_chrono);
}

function DoBroadcastBibTimeFinish(objJSON) 
{
//	alert("DoBroadcastBibTimeFinish :"+JSON.stringify(objJSON));
	
	const bib = objJSON.bib;
	const course_phase = canoe.GetCodeCoursePhase();
	const tRanking = adv.GetTableUnique(wsContext.notify_ranking, 'ranking');
	const iRow = tRanking.GetIndexRow('Dossard', bib);

	if (bib == wsContext.bib_select)
	{
		const time_chrono = adv.GetChronoHHMMSSCC(objJSON.time_chrono);
		const rk_chrono = objJSON.rank_categ;
		
		var diff_chrono = '';
		var color_chrono = '';
		
		if (objJSON.diff_categ != undefined)
		{
			diff_chrono = adv.GetChronoDiffMMSSCC(objJSON.diff_categ);
			if (objJSON.diff_categ > 0)
				color_chrono = 'red';
			else
				color_chrono = 'green';
		}
		else
		{
			if (objJSON.time_chrono > 0)
				color_chrono = 'green';
			else
				color_chrono = 'red';
		}
		
		if (wsContext.timeoutInter != null)
		{
			window.clearTimeout(wsContext.timeoutInter);
			wsContext.timeoutInter = null;
		}

		if (wsContext.timeoutFinish != null)
			window.clearTimeout(wsContext.timeoutFinish);

		wsContext.timeoutFinish = window.setTimeout(function() { 
				wsContext.timeoutFinish = null; 
				wsContext.bib_select = -1; 
				HideBlockFinish();
				ResetLeader();
			},	wsContext.timeoutFinishDelay
		);
		
	//	alert(time_chrono+'/'+diff_chrono+'/'+color_chrono+'/'+rk_chrono);
			
		document.querySelector('#block_finish .bib').innerHTML = bib;
		
		SetName('#block_finish', tRanking, iRow);
		SetNation('#block_finish', tRanking, iRow);
		SetCateg('#block_finish', tRanking, iRow);

		document.querySelector('#block_finish .rank').innerHTML = rk_chrono;
		document.querySelector('#block_finish .time').innerHTML = time_chrono;

		document.querySelector('#block_finish .diff').innerHTML = diff_chrono;
		if (color_chrono == 'red')
		{
			document.querySelector("#block_finish").classList.remove('green');
			document.querySelector("#block_finish").classList.add('red');
		}
		else 
		{
			document.querySelector("#block_finish").classList.add('green');
			document.querySelector("#block_finish").classList.remove('red');
		}
		
		ShowBlockFinish();
	}
	
	if (iRow >= 0)
		tRanking.UpdateRankingTime(iRow, tRanking.GetIndexColumn('Tps'+course_phase), tRanking.GetIndexColumn('Cltc'+course_phase), tRanking.GetCellInt('Tps'+course_phase,iRow), objJSON.time_chrono);
}

function OnBroadcastRunErase(objJSON)
{
	if (wsContext.timeoutFinish != null)
	{
		window.clearTimeout(wsContext.timeoutFinish);
		wsContext.timeoutFinish = null;
	}

	if (wsContext.timeoutInter != null)
	{
		window.clearTimeout(wsContext.timeoutInter);
		wsContext.timeoutInter = null;
	}
	
	wsContext.bib_select = -1;
	ResetLeader();
	document.getElementById("block_running").style.display = 'none';

	OnOpenWebSocketCommand();
}

function OnFlowOnCourse(objJSON)
{
//	alert("OnFlowOnCourse :"+JSON.stringify(objJSON));

	if (wsContext.timeoutFinish != null || wsContext.timeoutInter != null)
		return;

	const tOnCourse = adv.GetTableUnique(objJSON, 'table');
	if (tOnCourse == null || typeof tOnCourse !== 'object')
		return;

	const nb = tOnCourse.GetNbRows();
	if (wsContext.bib_select <= 0)
		wsContext.bib_select = GetBibSelect(tOnCourse);

	if (wsContext.bib_select > 0)
	{
		const i = tOnCourse.GetIndexRow('bib', wsContext.bib_select);
		if (i >= 0)
		{
			document.querySelector("#block_running .time").innerHTML = tOnCourse.GetCellChrono('time', i, 'HHMMSSCC');
			const block_running = document.getElementById("block_running");
			if (block_running != null && block_running.style.display == 'none')
				block_running.style.display = 'block';
			
			if (wsContext.leader_index < 0)
				SetLeader();
			
			if (wsContext.leader_index >= 0)
				ShowLeader(tOnCourse.GetCellInt('time', i));

			HideBlockStart(tOnCourse.GetCellInt('time', i));
		}
	}
	else
	{
		wsContext.bib_select = GetBibStart();
		if (wsContext.bib_select > 0)
		{
			const tRanking = adv.GetTableUnique(wsContext.notify_ranking, 'ranking');
			const iRow = tRanking.GetIndexRow('Dossard', wsContext.bib_select);
			document.querySelector('#block_start .bib').innerHTML = wsContext.bib_select;

			SetName('#block_start', tRanking, iRow);
			SetNation('#block_start', tRanking, iRow);
			SetCateg('#block_start', tRanking, iRow);
	
			ShowBlockStart();
		}
	}
}

function SetName(blockName, tRanking, iRow)
{
	let el = document.querySelector(blockName+' .name');
	el.innerHTML = '';
	if (iRow >= 0)
	{
		let bateau = tRanking.GetCell('Bateau', iRow);
		let iSeparator = bateau.indexOf('/');
		if (iSeparator > 0)
		{
			let equipier1 = bateau.substring(0, iSeparator).trim();
			let equipier2 = bateau.substring(iSeparator+1).trim();
			el.innerHTML = equipier1+'<br>'+equipier2;
			el.style.fontSize = "25pt";
		}
		else
		{
			el.innerHTML = bateau;
			el.style.fontSize = "50pt";
		}
	}
}

function SetNation(blockName, tRanking, iRow)
{
	let nation = '';
	if (iRow >= 0)
		nation = tRanking.GetCell('Code_nation', iRow);

	document.querySelector(blockName+' .nation').innerHTML = nation;
	if (nation == '')
		document.querySelector(blockName+' .img_nation').src = "./img/Flags/Empty.png";
	else
		document.querySelector(blockName+' .img_nation').src = "./img/Flags/"+nation+".png";
}

function SetCateg(blockName, tRanking, iRow)
{
	if (iRow >= 0)
		document.querySelector(blockName+' .categ').innerHTML = tRanking.GetCell('Code_categorie', iRow);
	else
		document.querySelector(blockName+' .categ').innerHTML = '';
}

function GetBibSelect(tOnCourse)
{
	const nb = tOnCourse.GetNbRows();
	if (nb > 0)
	{
		if (wsContext.bib_filter == 'pair')
		{
			var r = nb-1;
			while (r >= 0)
			{
				if (tOnCourse.GetCellInt('bib', r) % 2 == 0)
					return tOnCourse.GetCellInt('bib', r);
				--r;
			}
		}
		else if (wsContext.bib_filter == 'odd')
		{
			var r = nb-1;
			while (r >= 0)
			{
				if (tOnCourse.GetCellInt('bib', r) % 2 == 1)
					return tOnCourse.GetCellInt('bib', r);
				--r;
			}
		}
		else
		{
			return tOnCourse.GetCellInt('bib', nb-1);
		}
	}

	return -1;
}

function GetBibStart()
{
	const tRanking = adv.GetTableUnique(wsContext.notify_ranking, 'ranking');
	const course_phase = canoe.GetCodeCoursePhase();

	tRanking.OrderBy('Cltc'+course_phase+',Heure_depart'+course_phase);
	for (let r = 0; r<tRanking.GetNbRows(); r++)
	{
		if (tRanking.GetCellInt('Tps'+course_phase, r, adv.chrono.KO) == adv.chrono.KO)
		{
			if (wsContext.bib_filter == 'pair')
			{
				if (tRanking.GetCellInt('Dossard', r) % 2 == 0)
					return tRanking.GetCellInt('Dossard', r);
			}
			else if (wsContext.bib_filter == 'odd')
			{
				if (tRanking.GetCellInt('Dossard', r) % 2 == 1)
					return tRanking.GetCellInt('Dossard', r);
			}
			else
			{
				return tRanking.GetCellInt('Dossard', r);
			}
		}
	}

	return -1;
}

function ResetLeader()
{
	wsContext.leader_index = -1;
	document.querySelector('#block_leader .name').innerHTML = '';
	document.querySelector('#block_leader .time').innerHTML = '';
}

function SetLeader()
{
	wsContext.leader_index = -1;

	if (wsContext.bib_select > 0)
	{
		const tRanking = adv.GetTableUnique(wsContext.notify_ranking, 'ranking');
		const i = tRanking.GetIndexRow('Dossard', wsContext.bib_select);
		if (i >= 0)
		{
			const epreuve = tRanking.GetCell('Code_categorie', i);
			
			const course_phase = canoe.GetCodeCoursePhase();
			tRanking.OrderBy('Cltc'+course_phase+',Heure_depart'+course_phase);
			
			for (let r = 0; r<tRanking.GetNbRows(); r++)
			{
				if (tRanking.GetCell('Code_categorie', r) == epreuve)
				{
					if (tRanking.GetCellInt('Tps'+course_phase, r, -1) > 0)
						wsContext.leader_index = r;
					break;
				}
			}
		}
	}
}

function SetLeaderName(el)
{
	if (el != null)
	{
		el.innerHTML = '';
		if (wsContext.leader_index >= 0)
		{
			const tRanking = adv.GetTableUnique(wsContext.notify_ranking, 'ranking');
			let bateau = tRanking.GetCell('Bateau', wsContext.leader_index);

			let iSeparator = bateau.indexOf('/');
			if (iSeparator > 0)
			{
				let equipier1 = bateau.substring(0, iSeparator).trim();
				if (equipier1.length > 15)
					equipier1 = equipier1.substring(0,14)+'.';

				let equipier2 = bateau.substring(iSeparator+1).trim();
				if (equipier2.length > 15)
					equipier2 = equipier2.substring(0,14)+'.';
				
				el.innerHTML = equipier1+'<br>'+equipier2;
				el.style.fontSize = "16pt";
			}
			else
			{
				el.innerHTML = bateau;
				el.style.fontSize = "24pt";
			}
		}
	}
}

function ShowLeader(tpsRunning)
{
	const block_leader = document.getElementById("block_leader");
	if (block_leader != null)
	{
		if (wsContext.leader_index >= 0 && tpsRunning > 0)
		{
			const tRanking = adv.GetTableUnique(wsContext.notify_ranking, 'ranking');
			const course_phase = canoe.GetCodeCoursePhase();
			const nbInter = canoe.GetNbInter();

			for (let k = 1; k<=nbInter; k++)
			{
				const tpsInter = tRanking.GetCellInt('Tps'+course_phase+'_inter'+k, wsContext.leader_index);
				if (tpsInter > 0)
				{
					if (tpsRunning + wsContext.leader_before_inter >= tpsInter && tpsRunning < tpsInter)
					{
						SetLeaderName(document.querySelector('#block_leader .name'));
						document.querySelector('#block_leader .time').innerHTML = tRanking.GetCellChrono('Tps'+course_phase+'_inter'+k, wsContext.leader_index, 'HHMMSSCC');
						block_leader.style.display = 'block';
						return;
					}
				}
			}

			const tpsFinish = tRanking.GetCellInt('Tps'+course_phase, wsContext.leader_index);
			if (tpsFinish > 0)
			{
				if (tpsRunning + wsContext.leader_before_finish >= tpsFinish && tpsRunning < tpsFinish)
				{
					SetLeaderName(document.querySelector('#block_leader .name'));
					document.querySelector('#block_leader .time').innerHTML = tRanking.GetCellChrono('Tps'+course_phase, wsContext.leader_index, 'HHMMSSCC');
					block_leader.style.display = 'block';
					return;
				}
			}
		}
	}
}

function ShowBlockFinish()
{
	var el;

	el = document.getElementById("block_start");
	if (el != null)
		el.style.display = 'none';
	
	el = document.getElementById("block_running");
	if (el != null)
		el.style.display = 'none';

	el = document.getElementById("block_leader");
	if (el != null)
		el.style.display = 'none';

	el = document.getElementById("block_inter");
	if (el != null)
		el.style.display = 'none';

	el = document.getElementById("block_finish");
	if (el != null)
		el.style.display = 'block';
}

function HideBlockFinish()
{
	var el;

	el = document.getElementById("block_finish");
	if (el != null)
		el.style.display = 'none';
}

function ShowBlockInter()
{
	var el;
	
	el = document.getElementById("block_leader");
	if (el != null)
		el.style.display = 'none';

	el = document.getElementById("block_running");
	if (el != null)
		el.style.display = 'none';

	el = document.getElementById("block_start");
	if (el != null)
		el.style.display = 'block';

	el = document.getElementById("block_inter");
	if (el != null)
		el.style.display = 'block';
}

function HideBlockInter()
{
	var el;
	
	el = document.getElementById("block_leader");
	if (el != null)
		el.style.display = 'none';

	el = document.getElementById("block_inter");
	if (el != null)
		el.style.display = 'none';
}

function ShowBlockStart()
{
	var el;
	
	el = document.getElementById("block_start");
	if (el != null)
		el.style.display = 'block';
}

function HideBlockStart(tpsRunning)
{
	el = document.getElementById("block_start");
	if (el != null)
 	{
		if (el.style.display == 'block')
		{
			if (tpsRunning > wsContext.timeoutStartDelay && wsContext.timeoutStartDelay > 0)
				el.style.display = 'none';
		}
		else if  (el.style.display == 'none')
		{
			const tRanking = adv.GetTableUnique(wsContext.notify_ranking, 'ranking');
			const iRow = tRanking.GetIndexRow('Dossard', wsContext.bib_select);
			if (iRow >= 0)
			{
				el.style.display = 'block';

				document.querySelector('#block_start .bib').innerHTML = wsContext.bib_select;

				SetName('#block_start', tRanking, iRow);
				SetNation('#block_start', tRanking, iRow);
				SetCateg('#block_start', tRanking, iRow);
			}
		}
	}
}

function Init()
{
	wsContext.lang = 'fr';
	wsContext.url = wsParams.url;
	wsContext.port = wsParams.port;
	
	const queryString = window.location.search;
	const urlParams = new URLSearchParams(queryString);
	
	wsContext.bib_filter = ''; 
	if (urlParams.has('bib_filter'))
		wsContext.bib_filter = urlParams.get('bib_filter');

	wsContext.timeoutFinish = null;
	wsContext.timeoutInter = null;

	wsContext.bib_select = -1;
	ResetLeader();

	wsContext.leader_before_inter = 5000;
	wsContext.leader_before_finish = 7000;
	
	wsContext.timeoutFinishDelay = 10000;
	wsContext.timeoutInterDelay = 5000;
	wsContext.timeoutStartDelay = 0;
	
	// Command Notification
	wsContext.mapCommand.set('<race_load>', OnCommandRaceLoad);
	wsContext.mapCommand.set('<epreuve_load>', OnCommandEpreuveLoad);
	
	// Broadcast Notification
	wsContext.mapCommand.set('<run_erase>', OnBroadcastRunErase);
	wsContext.mapCommand.set('<penalty_add>', OnBroadcastPenaltyAdd);
	wsContext.mapCommand.set('<bib_time>', OnBroadcastBibTime);
	
	// Flow Notification
	wsContext.mapCommand.set('<on_course>', OnFlowOnCourse);

	// Ouverture ws 
	wsContext.OpenWebSocketCommand(OnOpenWebSocketCommand);
}
